#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>


int sig=0; /* va servir pour savoir quel signal à été reçus */

void traitantMinutes(){
	sig = 1;
}

void traitantHeures(){
	sig = 2;
}

void traitantEmpty(){}

int main(int argc,char* argv[]){
	int pid_minutes;
	int pid_heures;
	int heures, minutes, secondes;
	switch (argc){
		case 2:
			heures=atoi(argv[1]);
			minutes=0;
			secondes=0;
			break;
		case 3:
			heures=atoi(argv[1]);
			minutes=atoi(argv[2]);
			secondes=0;
			break;
		case 4:
			heures=atoi(argv[1]);
			minutes=atoi(argv[2]);
			secondes=atoi(argv[3]);
			break;
		default:
			heures=0;
			minutes=0;
			secondes=0;
	}
	printf("Inititalisation à %d:%d:%d\n", heures, minutes, secondes);
	pid_minutes=fork();
	switch(pid_minutes){
		case -1 :
			perror("erreur de fork");
			return 1;
			break;
		case  0 : 
			pid_heures = fork();
			switch(pid_heures){
				case -1 :
					perror("erreur de fork");
					return 1;
					break;
				case  0 :
					while (1){
						if(signal(SIGUSR2, traitantHeures)== SIG_ERR ){
							perror("Mauvais signal");
						}
						if(signal(SIGUSR1, traitantMinutes)== SIG_ERR ){
							perror("Mauvais signal");
						}
						pause();
						if (sig == 2 ){
							heures++;
							if (heures >= 24){
								heures=0;
							}
							printf("Heures : %d\n", heures);
						}
					}
					break;
				default:
					while(1){					
						if(signal(SIGUSR1, traitantMinutes)== SIG_ERR ){
							perror("Mauvais signal");
						}
						if(signal(SIGUSR2, traitantHeures)== SIG_ERR ){
							perror("Mauvais signal");
						}
						pause();
						if (sig == 1 ){
							minutes++;
							if (minutes >= 60){
								minutes=0;
								kill(0, SIGUSR2);
							}
							printf("Minutes : %d\n", minutes);
						}
					}
			}			
			break;
		default:
			while (1){
				if(signal(SIGALRM, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}
				if(signal(SIGUSR1, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}
				if(signal(SIGUSR2, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}
				alarm(1);
				pause();
				secondes++;
				if (secondes >= 60){
					secondes=0;
					kill(0, SIGUSR1);
				}
				printf("Secondes : %d\n", secondes);
			}
	}
	return EXIT_SUCCESS;
}
