#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>


void traitantPong(){
	printf("Pong\n");
	alarm(2);
}

void traitantPing(){
	printf("Ping\n");
	alarm(2);
}

void traitantEmpty(){}

int main(int argc,char* argv[]){
	int ping=fork();
	int pong;
	int init = 1;
	switch(ping){
		case -1 :
			perror("erreur de fork");
			return 1;
			break;
		case  0 : 
			while(1){					
				if(signal(SIGALRM, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}				
				if(signal(SIGUSR1, traitantPing)== SIG_ERR ){
					perror("Mauvais signal");
				}
				pause(); /* Attend le SIGUSR1 */
				pause(); /* Attend le SIGALRM */
				kill(getppid(), SIGUSR1);
			}
			break;
		default:
			alarm(2); /* Permet d'être sur que le fils soit crée, 2s d'attente */			
			while (1){
				if(signal(SIGALRM, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}
				if(signal(SIGUSR1, traitantPong)== SIG_ERR ){
					perror("Mauvais signal");
				}
				pause(); /* Attend le SIGALRM */
				if (init != 1 )
					pause(); /* Attend le SIGUSR1 */
				kill(ping, SIGUSR1);
				init = 0;
			}
	}
	return EXIT_SUCCESS;
}
