#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>


void traitantEmpty(){}

int main(int argc,char* argv[]){
	int pid_minutes;
	int pid_secondes;
	int heures, minutes, secondes;
	switch (argc){
		case 2:
			heures=atoi(argv[1]);
			minutes=0;
			secondes=0;
			break;
		case 3:
			heures=atoi(argv[1]);
			minutes=atoi(argv[2]);
			secondes=0;
			break;
		case 4:
			heures=atoi(argv[1]);
			minutes=atoi(argv[2]);
			secondes=atoi(argv[3]);
			break;
		default:
			heures=0;
			minutes=0;
			secondes=0;
	}
	printf("Inititalisation à %d:%d:%d\n", heures, minutes, secondes);
	pid_minutes=fork();
	switch(pid_minutes){
		case -1 :
			perror("erreur de fork");
			return 1;
			break;
		case  0 : 
			pid_secondes = fork();
			switch(pid_secondes){
				case -1 :
					perror("erreur de fork");
					return 1;
					break;
				case  0 :
					while (1){

						if(signal(SIGALRM, traitantEmpty)== SIG_ERR ){
							perror("Mauvais signal");
						}
						alarm(1);
						pause();
						secondes++;
						if (secondes >= 60){
							secondes=0;
						}
						printf("Secondes : %d\n", secondes);
					}
					break;
				default:
					while(1){					
						if(signal(SIGALRM, traitantEmpty)== SIG_ERR ){
							perror("Mauvais signal");
						}
						alarm(60);
						pause();
						minutes++;
						if (minutes >= 60){
							minutes=0;
							kill(getppid(), SIGUSR1);
						}
						printf("Minutes : %d\n", minutes);
					}
			}			
			break;
		default:
			while (1){
				if(signal(SIGALRM, traitantEmpty)== SIG_ERR ){
					perror("Mauvais signal");
				}
				alarm(60*60);
				pause();
				heures++;
				if (heures >= 24){
					heures=0;
				}
				printf("Heures : %d\n", heures);
			}
	}
	return EXIT_SUCCESS;
}
